<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kd7w2jm6rvvx6pnfgbmafdxkx875y5cf-vendored-sources/serde_derive-1.0.140/src/internals/symbol.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>symbol.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../serde_derive/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../serde_derive/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../serde_derive/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::fmt</span>::{<span class="self">self</span>, <span class="ident">Display</span>};
<span class="kw">use</span> <span class="ident">syn</span>::{<span class="ident">Ident</span>, <span class="ident">Path</span>};

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Symbol</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span>);

<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">ALIAS</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;alias&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">BORROW</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;borrow&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">BOUND</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;bound&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">CONTENT</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;content&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">CRATE</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;crate&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">DEFAULT</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;default&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">DENY_UNKNOWN_FIELDS</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;deny_unknown_fields&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">DESERIALIZE</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;deserialize&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">DESERIALIZE_WITH</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;deserialize_with&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">FIELD_IDENTIFIER</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;field_identifier&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">FLATTEN</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;flatten&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">FROM</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;from&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">GETTER</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;getter&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">INTO</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;into&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">OTHER</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;other&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">REMOTE</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;remote&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">RENAME</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;rename&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">RENAME_ALL</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;rename_all&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">SERDE</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;serde&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">SERIALIZE</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;serialize&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">SERIALIZE_WITH</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;serialize_with&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">SKIP</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;skip&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">SKIP_DESERIALIZING</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;skip_deserializing&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">SKIP_SERIALIZING</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;skip_serializing&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">SKIP_SERIALIZING_IF</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;skip_serializing_if&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">TAG</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;tag&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">TRANSPARENT</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;transparent&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">TRY_FROM</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;try_from&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">UNTAGGED</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;untagged&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">VARIANT_IDENTIFIER</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;variant_identifier&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">WITH</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;with&quot;</span>);
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">EXPECTING</span>: <span class="ident">Symbol</span> <span class="op">=</span> <span class="ident">Symbol</span>(<span class="string">&quot;expecting&quot;</span>);

<span class="kw">impl</span> <span class="ident">PartialEq</span><span class="op">&lt;</span><span class="ident">Symbol</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">Ident</span> {
    <span class="kw">fn</span> <span class="ident">eq</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">word</span>: <span class="kw-2">&amp;</span><span class="ident">Symbol</span>) -&gt; <span class="ident">bool</span> {
        <span class="self">self</span> <span class="op">==</span> <span class="ident">word</span>.<span class="number">0</span>
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">PartialEq</span><span class="op">&lt;</span><span class="ident">Symbol</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Ident</span> {
    <span class="kw">fn</span> <span class="ident">eq</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">word</span>: <span class="kw-2">&amp;</span><span class="ident">Symbol</span>) -&gt; <span class="ident">bool</span> {
        <span class="kw-2">*</span><span class="self">self</span> <span class="op">==</span> <span class="ident">word</span>.<span class="number">0</span>
    }
}

<span class="kw">impl</span> <span class="ident">PartialEq</span><span class="op">&lt;</span><span class="ident">Symbol</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">Path</span> {
    <span class="kw">fn</span> <span class="ident">eq</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">word</span>: <span class="kw-2">&amp;</span><span class="ident">Symbol</span>) -&gt; <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">is_ident</span>(<span class="ident">word</span>.<span class="number">0</span>)
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">PartialEq</span><span class="op">&lt;</span><span class="ident">Symbol</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Path</span> {
    <span class="kw">fn</span> <span class="ident">eq</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">word</span>: <span class="kw-2">&amp;</span><span class="ident">Symbol</span>) -&gt; <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">is_ident</span>(<span class="ident">word</span>.<span class="number">0</span>)
    }
}

<span class="kw">impl</span> <span class="ident">Display</span> <span class="kw">for</span> <span class="ident">Symbol</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">formatter</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="ident">formatter</span>.<span class="ident">write_str</span>(<span class="self">self</span>.<span class="number">0</span>)
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="serde_derive" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>